//
// The main function so we can test stuff..
//

#include <dirent.h>
#include <syslog.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/mount.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <shadow.h>
#include <syslog.h>

// maximum buffer size
#define maxLen 1024
#define  MOUNT_DIR      "/home/"

char *readfile(char *filename, int *size);
int createMountDirectoryName(char *SysPath, char *MountPath);

int main(int argc, char** argv)
{

  char MountPath[256];     // <<<<<<<<<<<< where to mount it
  // current directory
  char SysPath[maxLen] = "./";
  if(createMountDirectoryName(SysPath, MountPath) < 0) {
    return;
  }
  printf("MountPath is %s\n", MountPath);
}


// ----------------------------------------------------------------------
// Creates the name of the directory to which a SCSI device is
// mounted. It reads the product name and the serial number from
// the "SysPath" directory.
int createMountDirectoryName(char *SysPath, char *MountPath)
{
  strcat(SysPath, "product");
  printf("Syspath %s\n", SysPath);
  FILE *File = fopen(SysPath, "r");
  if(!File) {
    printf("Cannot get model from \"%s\".", SysPath);
    return -1;
  }

  // first part of mount folder is the model name
  strcpy(MountPath, MOUNT_DIR);
  char *p = MountPath + strlen(MountPath);
  *(p + fread(p, 1, 200, File)) = 0;
  fclose(File);

  p = strrchr(SysPath, '/');
  if(p == 0)  return -1;
  strcpy(p+1, "serial");

	File = fopen(SysPath, "r");
	if(!File)
	{
		printf("Cannot get serial number from \"%s\".", SysPath);
		//return -1;

		// create fake serial number
		// just use the name, don't add anything
		//strcat(MountPath,"-1111");
	}
	else
	{
		p = MountPath + strlen(MountPath);
		*(p++) = '-';
		*(p + fread(p, 1, 4, File)) = 0; // second part of mount folder are ...
		fclose(File);                    // ... 4 characters of the S/N
	}

  // Replace forbidden characters in mount directory name with "_".
  p = MountPath + strlen(MOUNT_DIR) - 1;
  while(*(++p)) {
    if(*p == '-') continue;
    if((*p >=  '0') && (*p <= '9')) continue;
    if((*p >=  'A') && (*p <= 'Z')) continue;
    if((*p >=  'a') && (*p <= 'z')) continue;
    if(*p == '&') continue;
    *p = '_';
  }

  // MvdB
  // postprocess the name to see if there is a config for the mount name, 
  // so we can use a more sane name for that.
  // Since I am a Java weenie this code probably sucks, but it works ;)

  char *AliasConfFile = "drivealias.conf";
  char *AliasConfig = readfile(AliasConfFile,0);
  if (AliasConfig != NULL) {
    // try to get the correct value
    char *aliasValue = (char*)malloc(maxLen);
    char *tmp = (char*)malloc(maxLen);
    char *id = (char*)malloc(maxLen);
    strcpy(tmp, MountPath);
    strncpy(id, tmp+(strlen(MOUNT_DIR)), strlen(tmp)-strlen(MOUNT_DIR));
    if (get_value(AliasConfig, id, aliasValue) == 1) {
      printf("Changing mount directoryname to %s\n", aliasValue);
      strcpy(MountPath, MOUNT_DIR);
      strcat(MountPath, aliasValue);
    }
  }

  return 0;
}

// *******************************************************************
// Reads the file "filename" into memory and returns pointer to the buffer.
char *readfile(char *filename, int *size)
{
  FILE         *fp;
  char         *buffer;
  struct stat  info;

  if(stat(filename, &info) != 0)
    return 0;

  if((fp=fopen(filename, "r")) == 0)
    return 0;

  buffer = 0;
  for(;;) {
    if((buffer=(char*)malloc(info.st_size+1)) == 0)
      break;

    if(fread(buffer, 1, info.st_size, fp) != info.st_size) {
      free(buffer);
      buffer = 0;
      break;
    }

    buffer[info.st_size] = 0;
    if(size) *size = info.st_size;

    break;
  }

  (void)fclose(fp);

  return buffer;
}

// *******************************************************************
// Get value from master config file. "id" without '=' !!!
int get_value(char *buffer, char *id, char *output)
{
  char *p = id;
  do {
    p = strstr(buffer, p);
    if(!p) {
      *output = 0;
      return 0;
    }
    p += strlen(id);
  } while(*p != '=');
  p++;   // jump over '='

  char *end = strchr(p, '\n');
  if(end)  *end = 0;   // string end

  strcpy(output, p);

  if(end)  *end = '\n';   // back old character
  return 1;
}
